// Code generated by go-swagger; DO NOT EDIT.

package roles

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// UserRoleCreateHandlerFunc turns a function with the right signature into a user role create handler
type UserRoleCreateHandlerFunc func(UserRoleCreateParams) middleware.Responder

// Handle executing the request and returning a response
func (fn UserRoleCreateHandlerFunc) Handle(params UserRoleCreateParams) middleware.Responder {
	return fn(params)
}

// UserRoleCreateHandler interface for that can handle valid user role create params
type UserRoleCreateHandler interface {
	Handle(UserRoleCreateParams) middleware.Responder
}

// NewUserRoleCreate creates a new http.Handler for the user role create operation
func NewUserRoleCreate(ctx *middleware.Context, handler UserRoleCreateHandler) *UserRoleCreate {
	return &UserRoleCreate{Context: ctx, Handler: handler}
}

/*UserRoleCreate swagger:route POST /api/roles Roles userRoleCreate

Create role

*/
type UserRoleCreate struct {
	Context *middleware.Context
	Handler UserRoleCreateHandler
}

func (o *UserRoleCreate) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUserRoleCreateParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
